'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; }

var _Expression2 = require('../Expression');

var _Expression3 = _interopRequireDefault(_Expression2);

var unaryOperators = {
    '-': true,
    '+': true,
    '!': true,
    '~': true,
    'typeof': true,
    'void': true,
    'delete': true
};

var UnaryExpression = (function (_Expression) {
    _inherits(UnaryExpression, _Expression);

    // TODO: Should respect operator precedence: putting "-a" after "b" without parens should raise an error.

    function UnaryExpression(childNodes) {
        _classCallCheck(this, UnaryExpression);

        _get(Object.getPrototypeOf(UnaryExpression.prototype), 'constructor', this).call(this, 'UnaryExpression', childNodes);
    }

    _createClass(UnaryExpression, [{
        key: '_acceptChildren',
        value: function _acceptChildren(children) {
            if (children.currentElement.type === 'Punctuator' || children.currentElement.type === 'Keyword') {
                children.assertToken(children.currentElement.type, unaryOperators);
            } else {
                children.assertToken('Punctuator');
            }

            var operator = children.passToken().value;
            children.skipNonCode();

            var argument = children.passExpression();

            children.assertEnd();

            this._argument = argument;
            this._operator = operator;
        }
    }, {
        key: 'argument',
        get: function get() {
            return this._argument;
        }
    }, {
        key: 'operator',
        get: function get() {
            return this._operator;
        }
    }, {
        key: 'prefix',
        get: function get() {
            return true;
        }
    }]);

    return UnaryExpression;
})(_Expression3['default']);

exports['default'] = UnaryExpression;
module.exports = exports['default'];